#!/usr/bin/bash
#
# Ѵץ(convert Υåѡ)
#
# $0: [ץ] [ϳĥ] [ϳĥ]

# Хѿ
#   CONVERT_ARGV[]: convert ޥɤϤ
#   SRC_DIR: оݤΤǥ쥯ȥ
#   DST_DIR: ѴΥե֤ǥ쥯ȥ
#   SRC_FMT: Ѵоݤγĥ
#   DST_FMT: Ѵγĥ

# convert ޥɤΥץå
# :
#   $1: ץΤʤǼե
#   $2: ץΤǼե
check_convert_opts () {
    local file_1="$1"
    local file_2="$2"
    local line
    local file

    rm -f "${file_1}" "${file_2}" > /dev/null 2>&1
    : > "${file_1}"
    : > "${file_2}"

    convert | sed -n 's/^  -//p' | while read line; do
	if echo "${line}" | grep '^[^ ]* \{2,\}'; then
	    # ץȤʤ
	    file="${file_1}"
	else
	    # ץ
	    file="${file_2}"
	fi

	echo "$line" | sed 's/ .*//' >> "${file}" 
    done
}

# ץåХѿ
# ͤ򥻥åȤ
# :
#   $1: ץΤʤǼե
#   $2: ץΤǼե
#   $3: ... : ץȤؤΰ
# Хѿ
#   CONVERT_ARGV[]: convert ޥɤϤ
#   SRC_DIR: ооݤΤǥ쥯ȥ
#   DST_DIR: ѴΥե֤ǥ쥯ȥ
#   SRC_FMT: Ѵоݤγĥ
#   DST_FMT: Ѵγĥ
parse_opt () {
    local file_1="$1"
    local file_2="$2"
    shift 2

    local arg
    local idx
    local d

    SRC_DIR="."
    DST_DIR="."
    SRC_FMT=""
    DST_FMT=""

    while [ $# -gt 0 ]; do
	case "$1" in
	    -*)
		if [ "${SRC_FMT}${DST_FMT}" != "" ]; then
		    echo "Options might not be after formatting option." 1>&2
		    return 1
		fi
		arg="${1:1}"
		shift
		idx="${#CONVERT_ARGV[*]}"
		if grep -e "^${arg}\$" "${file_1}" 2> /dev/null; then
		    # ʤץ
		    CONVERT_ARGV[${idx}]="-${arg}"
		elif grep -e "^${arg}\$" "${file_2}" 2> /dev/null; then
		    # 륪ץ
		    CONVERT_ARGV[${idx}]="-${arg}"
		    if [ $# -eq 0 ]; then
			echo "Missing an option (-${arg})" 1>&2
			return 1
		    fi
		    CONVERT_ARGV[++${idx}]="$1"
		    shift
		elif [ ${arg} == "i" ]; then
		    # ϥեΤǥ쥯ȥ
		    if [ $# -eq 0 ]; then
			echo "Missing an option (-i)" 1>&2
			return 1
		    fi
		    SRC_DIR="$1"
		    shift
		elif [ ${arg} == "o" ]; then
		    # ϥեΤǥ쥯ȥ
		    if [ $# -eq 0 ]; then
			echo "Missing an option (-o)" 1>&2
			return 1
		    fi
		    DST_DIR="$1"
		    shift
		else
		    # ¸ΥץˤƤϤޤʤ
		    echo "Unrecognized option (-${arg})" 1>&2
		    return 1
		fi
		;;
	    *)
		# - ǻϤޤʤϥեޥå
		if [ "${DST_FMT}" != "" ]; then
		    # 2 ĤΰʾեޥåȻξ
		    if [ "${SRC_FMT}" != "" ]; then
		        # 3 ĤΥեޥåȻϥ顼
			echo "Too many format specification" 1>&2
			return 1
		    fi
		    SRC_FMT="${DST_FMT}"
		    DST_FMT="$1"
		else
		    DST_FMT="$1"
		fi

		shift
		;;
	esac
    done

    # {SRC,DST}_DIR Υå
    for d in "${SRC_DIR}" "${DST_DIR}"; do
	if [ ! -d "${d}" ] ; then
	    echo "No such directory(${d})" 1>&2
	    return 1
	fi
    done

    # SRC_FMT/DST_FMT Υå
    if [ "${DST_FMT}" == "" ] ; then
	echo "No format specified" 1>&2
	return 1
    fi
    if [ "${SRC_FMT}" == "${DST_FMT}" ]; then
	echo "Input/Output format are the same." 1>&2
	return 1
    fi
}

# util_common.bash ɤ߹
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

# 
check_convert_opts "${tmpdir}/arg_1" "${tmpdir}/arg_2"
parse_opt  "${tmpdir}/arg_1" "${tmpdir}/arg_2" "$@"
status=$?
if [ ${status} -ne 0 ]; then
    exit ${status}
fi

# оݥեɽ glob ѥ
case "${SRC_FMT}" in
    .*)
	src_glob="*${SRC_FMT}"
	;;
    "")
	src_glob="*"
	;;
    *)
	src_glob="*.${SRC_FMT}"
	;;
esac

# оݥե뤴ȤΥ롼
for src in "${SRC_DIR}/"${src_glob}; do
    # ̾եʳ̵
    if [ ! -f "${src}" ]; then
	continue
    fi

    # ѴΥե̾η
    dst=$(echo "${src##*/}" | sed 's/\.[^.]*$/.'"${DST_FMT}"/)
    if [ "${dst}" == "${src##*/}" ]; then
	dst="${src##*/}.${DST_FMT}"
    fi

    # convert μ¹
    convert "${CONVERT_ARGV[@]}" "${src}" "${DST_DIR}/${dst}"
done

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}
